module Cube where

import qualified Graphics.Rendering.OpenGL as GL
import Foreign.C.Types( CFloat )
import Graphics.UI.GLUT

cube :: CFloat -> CFloat -> CFloat -> IO ()
cube r g b = do
	GL.color $ GL.Color3 r g b
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 1.0 1.0 (-1.0), GL.Vertex3 (-1.0) 1.0 (-1.0), GL.Vertex3 (-1.0) 1.0 1.0, GL.Vertex3 1.0 1.0 (1.0::CFloat)]
	GL.color $ GL.Color3 (r+0.02) (g+0.02) (b+0.02)
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 1.0 (-1.0) 1.0, GL.Vertex3 (-1.0) (-1.0) 1.0, GL.Vertex3 (-1.0) (-1.0) (-1.0), GL.Vertex3 1.0 (-1.0) ((-1.0)::CFloat)]
	GL.color $ GL.Color3 (r+0.04) (g+0.04) (b+0.04)
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 1.0 1.0 1.0, GL.Vertex3 (-1.0) 1.0 1.0, GL.Vertex3 (-1.0) (-1.0) 1.0, GL.Vertex3 1.0 (-1.0) (1.0::CFloat)]
	GL.color $ GL.Color3 (r+0.06) (g+0.06) (b+0.06)
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 1.0 (-1.0) (-1.0), GL.Vertex3 (-1.0) (-1.0) (-1.0), GL.Vertex3 (-1.0) 1.0 (-1.0), GL.Vertex3 1.0 1.0 ((-1.0)::CFloat)]
	GL.color $ GL.Color3 (r+0.08) (g+0.08) (b+0.08)
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 (-1.0) 1.0 1.0, GL.Vertex3 (-1.0) 1.0 (-1.0), GL.Vertex3 (-1.0) (-1.0) (-1.0), GL.Vertex3 (-1.0) (-1.0) (1.0::CFloat)]
	GL.color $ GL.Color3 (r+0.1) (g+0.1) (b+0.1)
	GL.renderPrimitive GL.Quads $ mapM_ GL.vertex
		[GL.Vertex3 1.0 1.0 (-1.0), GL.Vertex3 1.0 1.0 1.0, GL.Vertex3 1.0 (-1.0) 1.0, GL.Vertex3 1.0 (-1.0) ((-1.0)::CFloat)]
	GL.hint PerspectiveCorrection $= Nicest